"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _useFieldApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));

var _FormGroup = _interopRequireDefault(require("carbon-components-react/lib/components/FormGroup/FormGroup.js"));

var _RadioButtonGroup = _interopRequireDefault(require("carbon-components-react/lib/components/RadioButtonGroup/RadioButtonGroup.js"));

var _RadioButton = _interopRequireDefault(require("carbon-components-react/lib/components/RadioButton/RadioButton.js"));

var _prepareProps = _interopRequireDefault(require("../prepare-props"));

var _helperTextBlock = _interopRequireDefault(require("../helper-text-block/helper-text-block"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var Radio = function Radio(props) {
  var _useFieldApi = (0, _useFieldApi2["default"])((0, _prepareProps["default"])(_objectSpread({
    type: 'radio'
  }, props))),
      labelText = _useFieldApi.labelText,
      disabled = _useFieldApi.disabled,
      input = _useFieldApi.input,
      options = _useFieldApi.options,
      FormGroupProps = _useFieldApi.FormGroupProps,
      helperText = _useFieldApi.helperText,
      meta = _useFieldApi.meta,
      validateOnMount = _useFieldApi.validateOnMount,
      rest = (0, _objectWithoutProperties2["default"])(_useFieldApi, ["labelText", "disabled", "input", "options", "FormGroupProps", "helperText", "meta", "validateOnMount"]);

  var invalid = (meta.touched || validateOnMount) && (meta.error || meta.submitError);
  var warnText = (meta.touched || validateOnMount) && meta.warning;
  return /*#__PURE__*/_react["default"].createElement(_FormGroup["default"], (0, _extends2["default"])({
    legendText: labelText
  }, FormGroupProps), /*#__PURE__*/_react["default"].createElement(_RadioButtonGroup["default"], (0, _extends2["default"])({}, input, {
    valueSelected: input.value,
    disabled: disabled
  }, rest), options.map(function (option) {
    return /*#__PURE__*/_react["default"].createElement(_RadioButton["default"], (0, _extends2["default"])({
      key: option.value,
      disabled: disabled,
      labelText: option.label,
      value: option.value
    }, option));
  })), /*#__PURE__*/_react["default"].createElement(_helperTextBlock["default"], {
    helperText: helperText,
    errorText: invalid,
    warnText: warnText
  }));
};

Radio.propTypes = {
  FormGroupProps: _propTypes["default"].object,
  isDisabled: _propTypes["default"].bool,
  label: _propTypes["default"].node,
  isRequired: _propTypes["default"].bool,
  options: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    label: _propTypes["default"].node,
    value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number])
  }))
};
var _default = Radio;
exports["default"] = _default;